--[[
************************************************************************
Project				: Broker_Extractor
Author				: zhinjio
Project Revision	: r47
Project Date		: 20110105000305

File				: Broker_Extractor.lua
Commit Author		: zhinjio
Commit Revision		: 47
Commit Date			: 20110105000305
************************************************************************
Description	:
	Main addon file. 

TODO		:

************************************************************************
(see bottom of file for changelog)
************************************************************************
--]]

-- For now, we need a hack in here to make sure ace3 loads before I do.
-- All hail disembeded libraries and their swift return....
LoadAddOn("Ace3")

local MODNAME = "Extractor"
local FULLNAME = "Broker_Extractor"
local Extractor = LibStub( "AceAddon-3.0" ):NewAddon( MODNAME, "AceEvent-3.0" )
local L = LibStub:GetLibrary( "AceLocale-3.0" ):GetLocale( MODNAME )
local AceConfig 		= LibStub("AceConfig-3.0")
local AceConfigReg 		= LibStub("AceConfigRegistry-3.0")
local AceConfigDialog 	= LibStub("AceConfigDialog-3.0")

_G[ MODNAME ] = Extractor
local addon = Extractor

local addonversion = "r47"
local addonauthor = "zhinjio"
local builddate = "20110105000305"

local modularOptions = {}
local tooltip
local LTT = LibStub:GetLibrary( "LibQTip-1.0" )

-- addon globals
-- addon.someValue = 0
addon.VERSION = 1.0
addon.me = ""
addon.currTT = 0
addon.show = false
addon.doneScanning = false

local db

function addon.Print( msg )
	local _, fh = DEFAULT_CHAT_FRAME:GetFont()
	fh = math.ceil( fh )
	local icon = "\124TInterface\\Addons\\" .. FULLNAME .. "\\icon:" .. fh .. "\124t"
	if ( msg ~= nil ) then
	   if( DEFAULT_CHAT_FRAME ) then
	      DEFAULT_CHAT_FRAME:AddMessage( icon .. " " .. MODNAME .. " : " .. msg, 0.6, 1.0, 1.0 )
	   end
	end
end

function addon.Debug( msg )
	if ( msg ~= nil ) then
		if ( db.options.display.debug ) then
			addon.Print( "DEBUG: " .. msg )
		end
	end
end
-- my custom tooltips have particular herbs and zones in them. store those values here
addon.ttHerbs = {
	[1] = "22710 765 2447 2449 785 2450",
	[2] = "2453 3820 3355 3369 3356 3357 3358 3821 3818 8836",
	[3] = "8838 8839 8845 8831 4625 3819 13464 13463 8846 13465 13466 13467",
	[4] = "22786 22785 22787 22788 22793 22789 22792 22791",
	[5] = "36901 36904 36907 36903 36906 36905 36908",
	[6] = "52983 52985 52984 52986 52987 52988"
}
addon.ttOre = {
	[11] = "2770",
	[12] = "2775 2771 2772",
	[13] = "2776 3858 7911 10620 rtv",
	[14] = "23424 23425 rad 23426",
	[15] = "36909 rcd 36912 rsd 36910",
	[16] = "53038 rod 52185 rev 52183 rpd"
}
addon.ttSkins = {
	[21] = "2318 2319",
	[22] = "4234 4304 8170",
	[23] = "21887 33568 52976"
}
addon.ttZones = {
	[1] = "22 56 17 21 25 16 35 59 52 34 12 38 46 4 40 28 65 49 3 18 66",
	[2] = "40 28 65 49 3 18 66 39 14 47 48 2 54 19 58 20 4 64 55",
	[3] = "58 20 24 64 55 41 51 6 45 10 23 8 63 50 68 27 69",
	[4] = "27 69 36 53 7 42 37",
	[5] = "29 9 70 15 26 44 11 57 31 67",
	[6] = "30 1 43 33 13 61 62 60",
	[11] = "17 12 38 21 4 25 16 56 35 59 46 65 22 5 34 49 3 40 18",
	[12] = "34 49 3 40 66 28 18 47 39 54 14 24 64 2 58 55 20",
	[13] = "14 24 64 2 58 55 20 10 6 23 41 51 63 68 45 8 50",
	[14] = "27 69 36 53 42 7 37 32",
	[15] = "29 9 70 15 26 44 57 31 67",
	[16] = "30 1 43 33 13 61 62 60",
	[21] = "38 12 65 4 34 46 17 40 3 39 48 47 28 14 49 2 54",
	[22] = "19 24 64 47 14 48 54 39 20 51 6 23 8 63 10 8",
	[23] = "42 36 7 27 37 44 57 70 31 26 29 13 30 33 62 61 43 1"
}

-- coloring agents
local function Green ( text )	return "|cff00c000" .. text .. "|r"	end
local function Orange ( text )	return "|cffcf8107" .. text .. "|r" end
local function Brown ( text )	return "|cffcf8107" .. text .. "|r" end
local function Yellow( text )	return "|cffffff00" .. text .. "|r" end
local function White( text )	return "|cffffffff" .. text .. "|r" end
local function Grey( text )		return "|cff808080" .. text .. "|r" end
local function Pink( text )		return "|cffff8080" .. text .. "|r" end

local function HideTooltip()
	tooltip:SetScript( "OnLeave", nil )
	tooltip:Hide()
	-- tooltip:Clear()
	-- tooltip:SetColumnLayout( 1, "LEFT" )
end

local function advanceTip()
	addon.shown = false
	local dbod = db.options.display
	local newtip = 0
	for i = 1, 16 do
		newtip = addon.currTT + i
		-- ( 1, 2, 3, 4, 5, 6 ... 11, 12, 13, 14, 15, 16 ... 21, 22, 23 )
		if ( ( newtip == 7 ) or ( newtip == 17 ) ) then
			newtip = newtip + 4
		elseif ( newtip == 24 ) then
			newtip = 1
		end
		if ( ( newtip == 1 ) and  ( dbod.herb1 == true ) ) then addon.shown = true; break end
		if ( ( newtip == 2 ) and  ( dbod.herb2 == true ) ) then addon.shown = true; break end
		if ( ( newtip == 3 ) and  ( dbod.herb3 == true ) ) then addon.shown = true; break end
		if ( ( newtip == 4 ) and  ( dbod.herb4 == true ) ) then addon.shown = true; break end
		if ( ( newtip == 5 ) and  ( dbod.herb5 == true ) ) then addon.shown = true; break end
		if ( ( newtip == 6 ) and  ( dbod.herb6 == true ) ) then addon.shown = true; break end
		if ( ( newtip == 11 ) and  ( dbod.ore1 == true ) ) then addon.shown = true; break end
		if ( ( newtip == 12 ) and  ( dbod.ore2 == true ) ) then addon.shown = true; break end
		if ( ( newtip == 13 ) and  ( dbod.ore3 == true ) ) then addon.shown = true; break end
		if ( ( newtip == 14 ) and  ( dbod.ore4 == true ) ) then addon.shown = true; break end
		if ( ( newtip == 15 ) and  ( dbod.ore5 == true ) ) then addon.shown = true; break end
		if ( ( newtip == 16 ) and  ( dbod.ore6 == true ) ) then addon.shown = true; break end
		if ( ( newtip == 21 ) and  ( dbod.skin1 == true ) ) then addon.shown = true; break end
		if ( ( newtip == 22 ) and  ( dbod.skin1 == true ) ) then addon.shown = true; break end
		if ( ( newtip == 23 ) and  ( dbod.skin1 == true ) ) then addon.shown = true; break end
	end
	addon.currTT = newtip
	addon.Debug( "currTT = " .. addon.currTT )
end

function addon:drawTooltip()
	local numColumns = 0
	tooltip:Hide()
	tooltip:Clear()
	if ( addon.shown == false ) then
		-- show the info tooltip instead
		addon.Debug( "infoTT" )
		tooltip:SetColumnLayout( 3, "LEFT", "CENTER", "RIGHT" )
		tooltip:AddHeader( MODNAME )
		tooltip:AddLine( " " )
		tooltip:AddLine( L["Author : "], " ", addonauthor )
		tooltip:AddLine( L["Version : "], " ", addonversion )
		tooltip:AddLine( L["Build Date : "], " ", builddate )
		tooltip:AddLine( L["Database Version : "], " ", db.options.display.dbVersion )
	else
		local typeText, typeTitle, typeMap = "", "", ""
		local typeTable = {}
		if ( ( addon.currTT >= 1 ) and ( addon.currTT <= 6 ) ) then
		-- HERB TOOLTIP
			typeText = L["Herb"]
			typeTitle = L["Herb name"]
			typeTable = addon.ttHerbs
			typeMap = addon.currTT
		elseif ( ( addon.currTT >= 11 ) and ( addon.currTT <= 16 ) ) then
			-- ORE TOOLTIP
			typeText = L["Ore"]
			typeTitle = L["Ore name"]
			typeTable = addon.ttOre
			typeMap = addon.currTT - 10
		else
			-- skin tooltip
			typeText = L["Skin"]
			typeTitle = L["Skin name"]
			typeTable = addon.ttSkins
			typeMap = addon.currTT - 20
		end
		
		tooltip:SetCellMarginV( 0 )
		local index = 2
		local colLayout = {}
		colLayout[1] = "LEFT" 		-- Resource name
		colLayout[2] = "CENTER" 	-- Resource icon
		if ( addon.currTT < 20 ) then -- only for ore and herbs
			colLayout[3] = "CENTER"		-- orange difficulty
			colLayout[4] = "CENTER"		-- yellow difficulty
			colLayout[5] = "CENTER"		-- green difficulty
			colLayout[6] = "CENTER"		-- grey difficulty
			index = 6
		end
		for i in string.gmatch( addon.ttZones[addon.currTT], "%d+") do
			table.insert( colLayout, "CENTER" ); index = index + 1;
		end
		tooltip:SetColumnLayout( index, unpack( colLayout ) )
		numColumns = index
		addon.Debug( "numCols = " .. numColumns )
		-- Headers...
		tooltip:AddHeader("a")
		tooltip:AddHeader("b")
		tooltip:AddLine(" ")
		tooltip:SetCell( 1, 1, MODNAME, "CENTER", numColumns )
		tooltip:SetCell( 2, 1, string.format( L["%s Map %d : Difficulties and node counts per zone"],
			typeText, typeMap ), "CENTER", numColumns )
		-- zones and stuff
		tooltip:AddLine(" ")
		tooltip:AddLine(" ")
		tooltip:AddLine(" ")
		tooltip:AddLine(" ")
		local zoneSpan = 2
		local startZ = 3
		if ( addon.currTT < 20 ) then -- only for ore and herbs
			startZ = 7
			zoneSpan = 6
			tooltip:SetCell( 7, 3, Yellow( L["Difficulty"] ), "CENTER", 4 )
		end
		local colorStart = startZ + 1
		tooltip:SetCell( 4, 1, Yellow( L["Zones >"] ), "RIGHT", zoneSpan )
		-- tooltip:SetCell( 5, 3, " ", "CENTER", 4 )
		-- tooltip:SetCell( 6, 3, " ", "CENTER", 4 )
		tooltip:SetCell( 7, 1, Yellow( typeTitle ), "LEFT", 2 )
		for i = 1, 4 do
			local zindex = startZ
			for j in string.gmatch( addon.ttZones[addon.currTT], "%d+" ) do
				local zone = j + 0;
				tooltip:SetCell( ( 3 + i ), zindex,
					Pink( string.sub( addon.ZoneMapping[zone].code, i, i ) ), "CENTER" )
				zindex = zindex + 1
			end
			for j = colorStart, numColumns, 2 do
				tooltip:SetCellColor( ( 3 + i ), j, 1, 1, 1, .3 )
			end
		end
		
		tooltip:AddSeparator( 2, .9, .6, 0, .5 )
		
		for i in string.gmatch( typeTable[addon.currTT], "%w+") do
			local rowLayout = {}
			local j = tonumber( i )
			local itemName = ""
			local icon = ""
			if ( j == nil ) then
				-- we have several "special" ore values
				--		rtv - Rich Thorium Vein
				--		rad - Rich Adamantite Deposit
				--		rcd - Rich Cobalt Deposit
				--		rsd - Rish Saronite Deposit
				--		rod - Rich Obsidium Deposit
				--		rev - Rich Elementium Vein
				--		rpd	- Rich Pyrite Deposit
				itemName = addon.OreLookup[i]
				-- icon = "Interface\\AddOns\\Broker_Extractor\\img\\" .. i 
				j = i
			else
				addon.Debug( i .."/".. j )
				itemName, _, _, _, _, _, _, _, _, icon = GetItemInfo(j)
			end
			addon.Debug( i .. " : " .. icon )
			icon = "Interface\\AddOns\\Broker_Extractor\\img\\" .. i 
			addon.Debug( i .. " : " .. icon )
			table.insert( rowLayout, itemName )
			table.insert( rowLayout, "|T" .. icon .. ":24|t" )
			if ( addon.currTT < 20 ) then -- only for ore and herbs
				table.insert( rowLayout, Orange( addon.nodeCounts[j]["orange"] ) )
				table.insert( rowLayout, Yellow( addon.nodeCounts[j]["yellow"] ) )
				table.insert( rowLayout, Green( addon.nodeCounts[j]["green"] ) )
				table.insert( rowLayout, Grey( addon.nodeCounts[j]["grey"] ) )
			end
			for z in string.gmatch( addon.ttZones[addon.currTT], "%d+" ) do
				local zone = z + 0
				if ( addon.nodeCounts[j][zone] ) then
					table.insert( rowLayout, addon.nodeCounts[j][zone] )
				else
					table.insert( rowLayout, " " )
				end
			end
			local numLine = tooltip:AddLine( unpack( rowLayout ) )
			-- cell coloring
			if ( addon.currTT < 20 ) then -- only for ore and herbs
				for i = 3, 6 do
					tooltip:SetCellColor( numLine, i, 1, 1, 1, .3 )
				end
			end
			for j = colorStart, numColumns, 2 do
				tooltip:SetCellColor( numLine, j, 1, 1, 1, .3 )
			end
		end
	end
	tooltip:AddSeparator( 2, .9, .6, 0, .5 )

	tooltip:AddLine(" ")
	local lineNum = tooltip:AddLine( "b" )
	tooltip:SetCell( lineNum, 1, L["Left-Click to cycle through maps"], "LEFT", numColumns )
	lineNum = tooltip:AddLine( "c" )
	tooltip:SetCell( lineNum, 1, L["Right-click for Configuration"], "LEFT", numColumns )
end

-- LDB stuff
local LDB = LibStub( "LibDataBroker-1.1" )
local launcher = LDB:NewDataObject( MODNAME, {
	type = "data source",
	text = "",
	label = FULLNAME,
	icon = "Interface\\Addons\\" .. FULLNAME .. "\\icon",
	OnClick = function( clickedframe, button )
				if button == "RightButton" then
					addon:ShowConfig()
				else
					if ( addon.doneScanning == true ) then
						tooltip:Release()
						tooltip = LTT:Acquire( MODNAME.."TT", 3, "LEFT", "CENTER", "RIGHT" ) -- or GameTooltip
						tooltip:SetScale( db.options.display.tipscale )
						advanceTip()
						addon:drawTooltip()
						tooltip:SetAutoHideDelay( db.options.display.autoHideDelay, clickedframe )
						tooltip:SmartAnchorTo( clickedframe )
						tooltip:Show()
					else
						addon.Print( L["Addon has not yet finished scanning resource items."] )
						addon.Print( L["Please try again once the scanning finishes."] )
					end
				end
	end,
	OnEnter = function ( self )
		if ( addon.doneScanning == true ) then
			tooltip = LTT:Acquire( MODNAME.."TT", 3, "LEFT", "CENTER", "RIGHT" ) -- or GameTooltip
			tooltip:SetScale( db.options.display.tipscale )
		
			addon:drawTooltip()
			tooltip:SetAutoHideDelay( db.options.display.autoHideDelay, self )
			tooltip:SmartAnchorTo( self )
			tooltip:Show()
		else
			addon.Print( L["Addon has not yet finished scanning resource items."] )
			addon.Print( L["Please try again once the scanning finishes."] )
		end
	end,
	OnLeave = function ( self )
		-- apparently some LDB displays pitch a fit when your launcher
		-- has an onenter, but no onleave. Pshaw, I say.
		return
	end,
} )

function addon.upgradeDB()
	local olddb = addon.db.factionrealm[addon.me]
	if ( olddb.options.display.dbVersion == "1.0" ) then
		-- original version
		olddb.options.display.debug = false
		olddb.options.display.dbVersion = "1.1"
		addon.Print( string.format( L["Database upgraded to %s"], "1.1" ) )
	end
	if ( olddb.options.display.dbVersion == "1.1" ) then
		olddb.options.display.herb1 = true		
		olddb.options.display.herb2 = true		
		olddb.options.display.herb3 = true		
		olddb.options.display.herb4 = true		
		olddb.options.display.ore1 = true		
		olddb.options.display.ore2 = true		
		olddb.options.display.dbVersion = "1.2"
		addon.Print( string.format( L["Database upgraded to %s"], "1.2" ) )
	end
	if ( olddb.options.display.dbVersion == "1.2" ) then
		olddb.options.display.disableitemtip = false
		olddb.options.display.dbVersion = "1.3"
		addon.Print( string.format( L["Database upgraded to %s"], "1.3" ) )
	end
	if ( olddb.options.display.dbVersion == "1.3" ) then
		olddb.options.display.herb5 = true		
		olddb.options.display.herb6 = true		
		olddb.options.display.ore3 = true		
		olddb.options.display.ore4 = true		
		olddb.options.display.ore5 = true		
		olddb.options.display.ore6 = true		
		olddb.options.display.skin1 = true		
		olddb.options.display.skin2 = true		
		olddb.options.display.skin3 = true		
		olddb.options.display.dbVersion = "1.4"
		addon.Print( string.format( L["Database upgraded to %s"], "1.4" ) )
	end
	if ( olddb.options.display.dbVersion == "1.4" ) then
		olddb.options.display.autoHideDelay = .1
		olddb.options.display.dbVersion = "1.5"
		addon.Print( string.format( L["Database upgraded to %s"], "1.5" ) )
	end
end

-- options stuff
local displayOptions = nil
local function giveDisplay()
	if (not displayOptions) then
		displayOptions = {
			order = 2,
			type = "group",
			name = L["Display Options"],
			desc = L["DISPLAY_OPTIONS_DESC"],
			args = {
				header1 = {
					order	= 21,
					type	= "header",
					name	= L["Display Options"],
				},
				desc = {
					order	= 22,
					type	= "description",
					name	= L["DISPLAY_OPTIONS_DESC"],
				},
				sound = {
					order	= 23,
					type	= "toggle",
					name	= L["Enable DEBUG"],
					desc	= L["DISPLAY_DEBUG_DESC"],
					get		= function() return db.options.display.debug end,
					set		= function() db.options.display.debug = not db.options.display.debug end,
				},
				tooltipscale = {
					order	= 24,
					type	= "range",
					name	= L["Tooltip Scale"],
					desc	= L["TOOLTIP_SCALE_DESC"],
					min		= .7,
					max		= 1.3,
					step	= .05,
					bigStep = .05,
					get		= function() return db.options.display.tipscale end,
					set		= function( info, v ) 
								db.options.display.tipscale = v
								tooltip:SetScale( v )
							  end,
				},
				autoHideDelay = {
					order	= 25,
					type	= "range",
					name	= L["Tooltip Auto-hide Delay"],
					desc	= L["TOOLTIP_DELAY_DESC"],
					min		= .1,
					max		= 2,
					step	= .1,
					bigStep = .1,
					get		= function() return db.options.display.autoHideDelay end,
					set		= function( info, v ) 
								db.options.display.autoHideDelay = v
							  end,
				},
				
				herb1 = {
					order	= 30,
					type	= "toggle",
					name	= L["Herb Set 1 Tooltip"],
					desc	= L["HERB1_TOGGLE_DESC"],
					get		= function() return db.options.display.herb1 end,
					set		= function() db.options.display.herb1 = not db.options.display.herb1 end,
				},
				herb2 = {
					order	= 31,
					type	= "toggle",
					name	= L["Herb Set 2 Tooltip"],
					desc	= L["HERB2_TOGGLE_DESC"],
					get		= function() return db.options.display.herb2 end,
					set		= function() db.options.display.herb2 = not db.options.display.herb2 end,
				},
				herb3 = {
					order	= 32,
					type	= "toggle",
					name	= L["Herb Set 3 Tooltip"],
					desc	= L["HERB3_TOGGLE_DESC"],
					get		= function() return db.options.display.herb3 end,
					set		= function() db.options.display.herb3 = not db.options.display.herb3 end,
				},
				herb4 = {
					order	= 33,
					type	= "toggle",
					name	= L["Herb Set 4 Tooltip"],
					desc	= L["HERB4_TOGGLE_DESC"],
					get		= function() return db.options.display.herb4 end,
					set		= function() db.options.display.herb4 = not db.options.display.herb4 end,
				},
				herb5 = {
					order	= 34,
					type	= "toggle",
					name	= L["Herb Set 5 Tooltip"],
					desc	= L["HERB5_TOGGLE_DESC"],
					get		= function() return db.options.display.herb5 end,
					set		= function() db.options.display.herb5 = not db.options.display.herb5 end,
				},
				herb6 = {
					order	= 35,
					type	= "toggle",
					name	= L["Herb Set 6 Tooltip"],
					desc	= L["HERB6_TOGGLE_DESC"],
					get		= function() return db.options.display.herb6 end,
					set		= function() db.options.display.herb6 = not db.options.display.herb6 end,
				},
				ore1 = {
					order	= 41,
					type	= "toggle",
					name	= L["Ore Set 1 Tooltip"],
					desc	= L["ORE1_TOGGLE_DESC"],
					get		= function() return db.options.display.ore1 end,
					set		= function() db.options.display.ore1 = not db.options.display.ore1 end,
				},
				ore2 = {
					order	= 42,
					type	= "toggle",
					name	= L["Ore Set 2 Tooltip"],
					desc	= L["ORE2_TOGGLE_DESC"],
					get		= function() return db.options.display.ore2 end,
					set		= function() db.options.display.ore2 = not db.options.display.ore2 end,
				},
				ore3 = {
					order	= 43,
					type	= "toggle",
					name	= L["Ore Set 3 Tooltip"],
					desc	= L["ORE3_TOGGLE_DESC"],
					get		= function() return db.options.display.ore3 end,
					set		= function() db.options.display.ore3 = not db.options.display.ore3 end,
				},
				ore4 = {
					order	= 44,
					type	= "toggle",
					name	= L["Ore Set 4 Tooltip"],
					desc	= L["ORE4_TOGGLE_DESC"],
					get		= function() return db.options.display.ore4 end,
					set		= function() db.options.display.ore4 = not db.options.display.ore4 end,
				},
				ore5 = {
					order	= 45,
					type	= "toggle",
					name	= L["Ore Set 5 Tooltip"],
					desc	= L["ORE5_TOGGLE_DESC"],
					get		= function() return db.options.display.ore5 end,
					set		= function() db.options.display.ore5 = not db.options.display.ore5 end,
				},
				ore6 = {
					order	= 46,
					type	= "toggle",
					name	= L["Ore Set 6 Tooltip"],
					desc	= L["ORE6_TOGGLE_DESC"],
					get		= function() return db.options.display.ore6 end,
					set		= function() db.options.display.ore6 = not db.options.display.ore6 end,
				},
				skin1 = {
					order	= 51,
					type	= "toggle",
					name	= L["Skin Set 1 Tooltip"],
					desc	= L["SKIN1_TOGGLE_DESC"],
					get		= function() return db.options.display.skin1 end,
					set		= function() db.options.display.skin1 = not db.options.display.skin1 end,
				},
				skin2 = {
					order	= 52,
					type	= "toggle",
					name	= L["Skin Set 2 Tooltip"],
					desc	= L["SKIN2_TOGGLE_DESC"],
					get		= function() return db.options.display.skin2 end,
					set		= function() db.options.display.skin2 = not db.options.display.skin2 end,
				},
				skin3 = {
					order	= 53,
					type	= "toggle",
					name	= L["Skin Set 3 Tooltip"],
					desc	= L["SKIN3_TOGGLE_DESC"],
					get		= function() return db.options.display.skin3 end,
					set		= function() db.options.display.skin3 = not db.options.display.skin3 end,
				},
				disableitemtip = {
					order	= 61,
					type	= "toggle",
					name	= L["Disable Item Tooltip Changes"],
					desc	= L["ITEMTT_DISABLE"],
					get		= function() return db.options.display.disableitemtip end,
					set		= function() db.options.display.disableitemtip = not db.options.display.disableitemtip end,
				},
			},
		}
	end
	return displayOptions
end

local options = nil
local function fullOptions()
	if (not options) then
		options = {
			type = "group",
			name = MODNAME,
			args = {
				general = {
					order	= 1,
					type	= "group",
					name	= L["General Information"],
					desc	= L["GENERAL_INFO_DESC"],
					args	= {
						header1 = {
							order	= 11,
							type	= "header",
							name	= L["General Information"],
						},
						desc = {
							order	= 12,
							type	= "description",
							name	= L["GENERAL_INFO_DESC"],
						},
						author = {
							order	= 13,
							type	= "description",
							name	= L["Author : "] .. addonauthor .. "\n",
						},
						version = {
							order	= 14,
							type	= "description",
							name	= L["Version : "] .. addonversion .. "\n",
						},
						builddate = {
							order	= 15,
							type	= "description",
							name	= L["Build Date : "] .. builddate .. "\n",
						},
						dbversion = {
							order	= 15,
							type	= "description",
							name	= L["Database Version : "] .. db.options.display.dbVersion .. "\n",
						},
						translators = {
							order	= 16,
							type	= "description",
							name	= string.format( L["Helpful Translators (thank you) : %s"],
									"xevilgrin(deDE) \n" )
						},
					},
				},
			},
		}
	end
	
	for k,v in pairs(modularOptions) do
		options.args[k] = (type(v) == "function") and v() or v
	end

	return options
end

function addon:SetupOptions()
	AceConfigReg:RegisterOptionsTable(MODNAME, fullOptions)
	self.optionsFrame = AceConfigDialog:AddToBlizOptions(MODNAME, nil, nil, "general")

	-- Fill up our modular options...
	self:RegisterModuleOptions("Display", giveDisplay(), L["Display Options"])
end

function addon:RegisterModuleOptions(name, optionsTable, displayName)
	modularOptions[name] = optionsTable
	self.optionsFrame[name] = AceConfigDialog:AddToBlizOptions(MODNAME, displayName, MODNAME, name)
end

function addon:ShowConfig()
	-- Open the profiles tab before, so the menu expands
	InterfaceOptionsFrame_OpenToCategory( self.optionsFrame["Display"] )
end

function addon.AddExtractData( tt, itemID, itemName, toggle )
	tt:AddLine( " " )
	local miner = {}
	if ( toggle == 1 ) then
		tt:AddLine( Brown( itemName .. L[" extracts into :"] ) )
		-- miner = addon.MinedData[itemID]
		if ( addon.ProspectingData[itemID] ) then
			miner = addon.ProspectingData[itemID]
		else 
			miner = addon.MillingData[itemID]
		end
		if ( miner ~= nil ) then
			local times = miner.times
			local yields = miner.yielded
			table.sort( yields, function( a, b ) return a.times > b.times end )
			for k, v in pairs( yields ) do
				local oName, oPerc = "", ""
				local itemInfo = GetItemInfo( k )
				if ( itemInfo ~= nil ) then
					oName = "  " .. itemInfo
					if ( v.max ~= 1 ) then
						oName = oName .. "(" .. v.min .. "-" .. v.max .. ")"
					end
					if ( times ~= 0 ) then
						oPerc = string.format( "%.1f%%", ( v.times / times * 100 ) )
					else
						oPerc = "?"
					end
					tt:AddDoubleLine( Yellow( oName ), White( oPerc ) )
				end
			end
		else
			tt:AddLine( Brown( L["No Extraction Statistics Found"] ) )
		end
	else
		tt:AddLine( Brown( itemName .. L[" extracted from :"] ) )
		-- miner = addon.MinedResults[itemID]
		if ( addon.GemData[itemID] ) then
			miner = addon.GemData[itemID]
		else
			miner = addon.PigmentData[itemID]
		end
		if ( miner ~= nil ) then
			for k, v in pairs( miner ) do
				local oName, oPerc = "", ""
				local itemInfo = GetItemInfo( k )
				if ( itemInfo ~= nil ) then
					oName = "  " .. itemInfo
					if ( v.max ~= 1 ) then
						oName = oName .. "(" .. v.min .. "-" .. v.max .. ")"
					end
					if ( v.tries ~= 0 ) then
						oPerc = string.format( "%.1f%%", ( v.yields / v.tries * 100 ) )
					else
						oPerc = "?"
					end
					tt:AddDoubleLine( Yellow( oName ), White( oPerc ) )
				end
			end
		else
			tt:AddLine( Brown( L["No Extraction Statistics Found"] ) )
		end
	end
	tt:AddLine( " " )
end

local Orig_GameTooltip_SetItem = GameTooltip:GetScript("OnTooltipSetItem")
GameTooltip:SetScript("OnTooltipSetItem", function( tooltip, ... )
	if Orig_GameTooltip_SetItem then
		Orig_GameTooltip_SetItem( tooltip, ... )
	end
	if ( db.options.display.disableitemtip == false ) then
		if ( tooltip ) then
			local name, link = tooltip:GetItem()
			if ( link ) then
				local itemID = string.match( link, "item:(%d+)" ) + 0
				if ( addon.Gatherable[itemID] == true ) then
					addon.AddExtractData( tooltip, itemID, name, 1 )
				elseif( addon.Extracted[itemID] == true ) then
					addon.AddExtractData( tooltip, itemID, name, 0 )
				end
			end
		end
	end
end)

local Orig_ItemRefTooltip_SetItem = ItemRefTooltip:GetScript("OnTooltipSetItem")
ItemRefTooltip:SetScript("OnTooltipSetItem", function(tooltip, ...)
	if Orig_ItemRefTooltip_SetItem then
		Orig_ItemRefTooltip_SetItem(tooltip, ...)
	end
	if ( db.options.display.disableitemtip == false ) then
		if ( tooltip ) then
			local name, link = tooltip:GetItem()
			if ( link ) then
				local itemID = string.match( link, "item:(%d+)" ) + 0
				if ( addon.Extractables[itemID] == true ) then
					addon.AddExtractData( tooltip, itemID, name, 1 )
				elseif( addon.Extracteds[itemID] == true ) then
					addon.AddExtractData( tooltip, itemID, name, 0 )
				end
			end
		end
	end
end)

local function stopScanning()
	if (Extractor_ScanLinksFrame) then
		Extractor_ScanLinksFrame:SetScript("OnUpdate", nil);
	end
	addon.Print( L["Item scanning completed."] )
	addon.doneScanning = true
end

function addon.scanItems()
	-- This code, while modified, is largely ripped straight from Xinhuan's wowequip
	-- Used by permission. Thanks Xinhuan!
	--
	-- my IDs to scan are going to be in addon.scanAll
	-- shove through them all, and see which ones pop up as unknown. put those in a new
	-- linear indexed table
	addon.Debug( "ScanAll is size: " .. #addon.ScanAll )
	-- don't bother with a scantable. just scan everything in ScanAll
	--[[
	local scanTable = {}
	for i in string.gmatch( addon.ScanAll, "%d+" ) do
		j = i + 0
		local itemName, _, _, _, _, _, _, _, _, icon = GetItemInfo(j)
		if ( icon == nil ) then
			table.insert( scanTable, j )
		end
	end
	addon.Debug( "size of scan table is " .. #scanTable ) ]]--

	if ( #addon.ScanAll ~= 0 ) then
		addon.Print( string.format( L["%d Extractor items are being force scanned."], #addon.ScanAll ) )
		addon.Print( L["Beginning item scanning now..."] )

		local lastScannedIndex = 1;
		local totalElapsed = 0;

		if (not Extractor_ScanLinksFrame) then
			Extractor_ScanLinksFrame = CreateFrame("Frame")
		end

		Extractor_ScanLinksFrame:SetScript("OnUpdate", function(self, elapsed)
			totalElapsed = totalElapsed + elapsed;
			if totalElapsed < 10 then
				return;
			end
			totalElapsed = 0;
			-- scan 40 at a time
			local numScanned = 1
			while ( numScanned < 40 ) do
				local currScan = addon.ScanAll[lastScannedIndex]
				if ( currScan ) then
					local itemToScan = GetItemInfo( currScan )
					-- Extractor_ScanLinksTooltip:SetHyperlink("item:"..currScan)
				end
				if ( lastScannedIndex == #addon.ScanAll ) then
					stopScanning()
					break
				else
					lastScannedIndex = lastScannedIndex + 1	
					numScanned = numScanned + 1
				end
			end
			return
		end )
	end
end

function addon:OnInitialize()
	-- Do Frame Creation stuff here
	-- addon:CreateFrames()
end

function addon:OnEnable()
    -- Called when the addon is loaded
	addon.me = UnitName( "player" )

	self.db = LibStub( "AceDB-3.0" ):New( MODNAME .. "_DB", nil, "Default" )
	-- do we have any data yet; for this toon? If not, init its table
	if not ( self.db.factionrealm[addon.me] ) then
		self.db.factionrealm[addon.me] = {
		-- Your saved variables stuff here
			options = {
				display = {
					debug = false,
					tipscale = 1,
					autoHideDelay = .1,
					dbVersion = "1.5",
					herb1 = true,
					herb2 = true,
					herb3 = true,
					herb4 = true,
					herb5 = true,
					herb6 = true,
					ore1 = true,
					ore2 = true,
					ore3 = true,
					ore4 = true,
					ore5 = true,
					ore6 = true,
					skin1 = true,
					skin2 = true,
					skin3 = true,
					disableitemtip = false,
				},
			},
		}
	else
		-- check if we need to upgrade the db
		addon.upgradeDB()
	end
	db = self.db.factionrealm[addon.me]

	addon.Debug( "In OnInit" )

	-- start up item scanning until everything is in cache
	addon.scanItems()

	addon:SetupOptions()
	-- Event listeners
    -- addon:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	advanceTip()
end

--[[
************************************************************************
CHANGELOG:

11/20/08 : 
	Initial version
************************************************************************
]]--